#-*- coding: utf-8 -*-

# Copyright 2012 Calculate Ltd. http://www.calculate-linux.org
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import soaplib, os
import soaplib
from soaplib.serializers.primitive import String, Integer
from soaplib.service import rpc


# client and server version
class VERS:
    @rpc(Integer, String, _returns = String)
    def versions (self, sid, VERSION) :
        
        s = _("Client Version - %s\n") %VERSION
        s += _("Server Version - %s") %self.SERV_VERS
        # report if necessary
        if float(VERSION) < float(self.SERV_VERS):
            s += _("\nPlease, update client")
        elif float(VERSION) > float(self.SERV_VERS):
            s += _("\nPlease, update server")
        else:
            s = _("Version %s") %self.SERV_VERS
        return s
