#-*- coding: utf-8 -*-

# Copyright 2012 Calculate Ltd. http://www.calculate-linux.org
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.

import collections
import soaplib

class Dec:
    conMethods = {}
    guiMethods = {}
    rightsMethods = {}
    
    # add wrapped method in list console methods
    @classmethod
    def console(cls,command):
        def wrapper(function):
            cls.conMethods[command] = function.__name__
            return function
        return wrapper

    # add wrapped method in list gui methods
    @classmethod
    def gui(cls, category, label = None, image = None):
        def wrapper(function):
            if not category in cls.guiMethods.keys():
                cls.guiMethods[category] = []
            cls.guiMethods[category].append(function.__name__)
            cls.guiMethods[category].append(label)
            cls.guiMethods[category].append(image)
            return function
        return wrapper

    # add needed rights for call method
    @classmethod
    def check_permissions(cls, add_right=[]):
        def wrapper(function):
            cls.rightsMethods[function.__name__] = add_right
            return function
        return wrapper
