#-*- coding: utf-8 -*-

# Copyright 2012 Calculate Ltd. http://www.calculate-linux.org
#
#  Licensed under the Apache License, Version 2.0 (the "License");
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.


from soaplib.serializers.primitive import String, Any
from soaplib.serializers.clazz import Array
from soaplib.serializers.clazz import ClassSerializer

import importlib

# add class parameter and table
class Parameter (ClassSerializer):
    class types:
        Name = String
        Label = String
        Type = String
        Opt = String
        Help = String
        Element = String
        Value = Any
        Choise = Array (String)
        
class Table (ClassSerializer):
    class types:
        head = Array (String)
        body = Array (String)
        values = Array (Array (String))

list_module = ["clean", "gen_pid", "check_rights", "cl_template", \
               "sid_pid_file", "gen_sid", "func", "api_types", 'test', 'test2', \
               'system_update', 'request', 'certificate', 'edit_groups']

imported_modules = []
pack = "calculate.core.server"
for module_name in list_module:
    imported_modules.append (importlib.import_module('%s.%s'\
                             %(pack, module_name)).CoreWsdl)

imported_modules.append(object)
imported = tuple (imported_modules)

# create metaclass, including all methods server class
Func_MetaClass = type ("Func_MetaClass", (imported), {})

